import 'package:dio/dio.dart';
import 'package:pmu/data/dtos/news_dto.dart';
import 'package:pmu/data/mappers/news_mapper.dart';
import 'package:pmu/data/repositories/api_interface.dart';
import 'package:pmu/domain/models/card.dart';
import 'package:pretty_dio_logger/pretty_dio_logger.dart';

class BbcRepository extends ApiInterface {
  static final Dio _dio = Dio()
    ..interceptors.add(PrettyDioLogger(
      requestHeader: true,
      requestBody: true,
    ));
  static const String _baseUrl = 'https://newsapi.org/v2';
  static const String _apiKey = '&apiKey=b9848c2aa43e4a0ba12dfe925db8513c';
  @override
  Future<List<CardData>?> loadData(
      {String? q, OnErrorCallback? onError}) async {
    try {
      final String url = '$_baseUrl/everything?q=$q$_apiKey';
      final Response<dynamic> response = await _dio.get<Map<dynamic, dynamic>>(
        url,
      );
      final NewsDto dto =
          NewsDto.fromJson(response.data as Map<String, dynamic>);
      final List<CardData>? data = dto.data?.map((e) => e.toDomain()).toList();
      return data;
    } on DioException catch (e) {
      onError?.call(e.response?.statusMessage);
    }
  }
}
